import { Canvas, CanvasRenderingContext2D } from "canvas";
import { MemeFramework } from "./types";
interface Layout {
    x: number;
    y: number;
    width: number;
    height: number;
    drawWidth: number;
    drawHeight: number;
    absolute?: boolean;
}
interface LayoutNode {
    node: MemeFramework.MemeNode;
    layout: Layout;
    children?: LayoutNode[];
    textContents?: string;
}
interface ParentLayout {
    x: number;
    y: number;
}
export declare function draw(layoutNode: LayoutNode, parent: ParentLayout, ctx: CanvasRenderingContext2D, canvas: Canvas): Promise<void>;
export interface LayoutDocument {
    ctx: CanvasRenderingContext2D;
    canvas: Canvas;
    layoutRoot: LayoutNode;
    elementById: Record<string, MemeFramework.MemeNode>;
}
export declare function build(root: MemeFramework.MemeNode): LayoutDocument;
export declare function render(root: MemeFramework.MemeNode): Promise<Canvas>;
export {};
